' PAL256.BAS - Quick Basic Palette functions example version 1.0
'
' This file contains some information about palette programming
'
' Programmed by FJTC for e-Software GP in 5/15/1997
' Last Upadate: 5/15/1997
'
' We will Not assume any damage that the contents of this file cause
' in your computer, brain or anything related you.
'
' You are free to use, modify and distribute it free of charge but you can
' not sell it. Use only for educational pupouse only.
'
' e-Software
'       Contact-us at:
'               http://www.icmsc.sc.usp.br/~andreeta/e-Software
'       or e-Mail us at:
'               chino@icmsc.sc.usp.br (FJTC)
'
'

' Declares ==================================================================
' Library
DECLARE SUB SetPaletteAtt (Att AS INTEGER, Red AS INTEGER, Green AS INTEGER, Blue AS INTEGER)
DECLARE SUB GetPaletteAtt (Att AS INTEGER, Red AS INTEGER, Green AS INTEGER, Blue AS INTEGER)
DECLARE SUB GetPalette (Pal() AS ANY)
DECLARE SUB SetPalette (Pal() AS ANY)
DECLARE SUB RotatePalette (Pal() AS ANY)
' Sample
DECLARE SUB Effect1 ()
DECLARE SUB EffectRotatePalette (Pal() AS ANY)

' Constants ==================================================================
        CONST MaxColors = 256
        CONST PalettePortSet = &H3C8
        CONST PalettePortGet = &H3C7
        CONST PalettePortWrite = PalettePortSet + 1
        CONST PalettePortRead = PalettePortGet + 2

' Data Types =================================================================
        TYPE RGBUnit
                Red AS INTEGER
                Green AS INTEGER
                Blue AS INTEGER
        END TYPE


' Main -----------------------------------------------------------------------
        SCREEN 13
        Effect1
' End Main

'
' Generate Effect 1
'
SUB Effect1
        ' Variables
        DIM Pal(MaxColors) AS RGBUnit
        DIM W AS INTEGER
       
        ' Draw Image
        FOR W = 16 TO 255
                CIRCLE (160 + (W / 70) ^ 4, 100 - ((128 - W) ^ 2) \ 250), W, W, , , .6
                CIRCLE (160 + (W / 70) ^ 4, 100 - (((128 - W) ^ 2) \ 250) + 1), W, W, , , .6
                CIRCLE (160 + (W / 70) ^ 4, 100 - (((128 - W) ^ 2) \ 250) - 1), W, W, , , .6
                CIRCLE (160 + (W / 70) ^ 4 + 1, 100 - (((128 - W) ^ 2) \ 250)), W, W, , , .6
                CIRCLE (160 + (W / 70) ^ 4 - 1, 100 - (((128 - W) ^ 2) \ 250)), W, W, , , .6
        NEXT W
        LOCATE 1, 1: PRINT "e Software 1997 - PAL256.BAS"

        GetPalette Pal() ' Get BIOS Palette
      
        ' Play Sample
        DO
                EffectRotatePalette Pal()
                SetPalette Pal()
                IF INP(&H60) = 1 THEN EXIT DO
        LOOP

END SUB

'
' Rotate palette data
'
SUB EffectRotatePalette (Pal() AS RGBUnit)
        DIM W AS INTEGER
        DIM temp AS RGBUnit

        temp = Pal(17)
        FOR W = 17 TO MaxColors - 1
                Pal(W) = Pal(W + 1)
        NEXT W
        Pal(MaxColors) = temp

END SUB

'
'
'
SUB GetPalette (Pal() AS RGBUnit)
        DIM W AS INTEGER

        OUT PalettePortGet, 0
        FOR W = 1 TO MaxColors
                Pal(W).Red = INP(PalettePortRead)
                Pal(W).Green = INP(PalettePortRead)
                Pal(W).Blue = INP(PalettePortRead)
        NEXT W

END SUB

'
' Get attribute RGB
'
SUB GetPaletteAtt (Att AS INTEGER, Red AS INTEGER, Green AS INTEGER, Blue AS INTEGER)

        OUT PalettePortGet, Att
        Red = INP(PalettePortRead)
        Green = INP(PalettePortRead)
        Blue = INP(PalettePortRead)

END SUB

'
' Set Entire Palette
'
SUB SetPalette (Pal() AS RGBUnit)
        DIM W AS INTEGER

        OUT PalettePortSet, 0
        FOR W = 1 TO MaxColors
                OUT PalettePortWrite, Pal(W).Red
                OUT PalettePortWrite, Pal(W).Green
                OUT PalettePortWrite, Pal(W).Blue
        NEXT W


END SUB

'
' Set Palette Attribute
'
SUB SetPaletteAtt (Att AS INTEGER, Red AS INTEGER, Green AS INTEGER, Blue AS INTEGER)
       
        OUT PalettePortSet, Att
        OUT PalettePortWrite, Red
        OUT PalettePortWrite, Green
        OUT PalettePortWrite, Blue
END SUB

